> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cognigy.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a new skill

> Creates a new skill with the provided information.



## OpenAPI

````yaml https://api-trial.cognigy.ai/swagger/openapi.json post /skills
openapi: 3.0.3
info:
  contact:
    email: support@example.com
    name: API Support
  description: API for managing agents and related resources
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  termsOfService: http://swagger.io/terms/
  title: Agents API
  version: '1.0'
servers:
  - url: https://api-trial.cognigy.ai/v1
security:
  - ApiKey: []
tags:
  - name: Agents
  - name: Brand personas
  - name: Tools
  - name: Built-in tools
  - name: Skills
  - name: Built-in skills
  - name: MCP servers
  - name: Tool references
paths:
  /skills:
    post:
      tags:
        - Skills
      summary: Create a new skill
      description: Creates a new skill with the provided information.
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/internal_skills.CreateSkillRequest'
        description: Skill data
        required: true
        x-originalParamName: skill
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/internal_skills.CreateAndReadSkillResponse
          description: Created
        '400':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailBadRequest
          description: Invalid request body or validation error
        '403':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailForbidden
          description: Access denied
        '409':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailConflict
          description: A skill with this name already exists in this project
        '500':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailInternalError
          description: Internal server error
components:
  schemas:
    internal_skills.CreateSkillRequest:
      properties:
        builtinSlug:
          example: my-skill-slug
          type: string
        bundledTools:
          items:
            type: string
          type: array
        compatibility:
          type: string
        description:
          type: string
        instructions:
          type: string
        license:
          type: string
        metadata:
          additionalProperties: {}
          type: object
        name:
          type: string
        projectId:
          description: MongoDB ObjectID represented as a hex string
          type: string
        resources:
          items:
            $ref: '#/components/schemas/internal_skills.SkillResourceRequest'
          type: array
        source:
          description: |-
            Source selects the creation flow. Empty or "user" creates a
            user-defined skill from the body fields. "builtin" instantiates
            from the builtin skill catalog identified by BuiltinSlug; in that
            case Name/Description/Instructions/etc. are taken from the catalog
            and any values provided in the body are ignored.
          example: user
          type: string
      required:
        - projectId
      type: object
    internal_skills.CreateAndReadSkillResponse:
      properties:
        builtinSlug:
          example: ''
          type: string
        bundledTools:
          items:
            type: string
          type: array
        compatibility:
          type: string
        createdAt:
          type: integer
        createdBy:
          example: 507f1f77bcf86cd799439011
          type: string
        description:
          type: string
        id:
          example: 507f1f77bcf86cd799439011
          type: string
        instructions:
          type: string
        lastChangedAt:
          type: integer
        lastChangedBy:
          example: 507f1f77bcf86cd799439011
          type: string
        license:
          type: string
        metadata:
          additionalProperties: {}
          type: object
        name:
          type: string
        organisationId:
          example: 507f1f77bcf86cd799439011
          type: string
        projectId:
          example: 507f1f77bcf86cd799439011
          type: string
        referenceId:
          type: string
        resources:
          items:
            $ref: '#/components/schemas/internal_skills.SkillResourceResponse'
          type: array
        source:
          example: user
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailBadRequest:
      properties:
        detail:
          example: request body validation failed
          type: string
        errors:
          items:
            $ref: >-
              #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.FieldError
          type: array
        instance:
          example: /v1/{resource}
          type: string
        status:
          example: 400
          type: integer
        title:
          example: Bad Request
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailForbidden:
      properties:
        detail:
          example: 'access denied: insufficient permissions'
          type: string
        instance:
          example: /v1/{resource}/{id}
          type: string
        status:
          example: 403
          type: integer
        title:
          example: Forbidden
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailConflict:
      properties:
        detail:
          example: a resource with this identifier already exists
          type: string
        instance:
          example: /v1/{resource}
          type: string
        status:
          example: 409
          type: integer
        title:
          example: Conflict
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailInternalError:
      properties:
        detail:
          example: internal server error
          type: string
        instance:
          example: /v1/{resource}
          type: string
        status:
          example: 500
          type: integer
        title:
          example: Internal Server Error
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    internal_skills.SkillResourceRequest:
      properties:
        content:
          type: string
        contentType:
          type: string
        encoding:
          type: string
        path:
          type: string
      required:
        - content
        - encoding
        - path
      type: object
    internal_skills.SkillResourceResponse:
      properties:
        content:
          type: string
        contentType:
          type: string
        encoding:
          type: string
        path:
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.FieldError:
      properties:
        field:
          type: string
        message:
          type: string
      type: object
  securitySchemes:
    ApiKey:
      description: '[Production] API key for production authentication'
      in: header
      name: X-API-Key
      type: apiKey

````